=== debian/changelog ===
ulfius (2.7.15-2.2) unstable; urgency=medium

  * Non-maintainer upload.
  * debian/patches/fix-ftbfs-32bit-arches-64bit-time_t.patch: Add
    upstream patch to fix FTBFS on 32-bit arches with 64-bit time_t.
    (Closes: #1066944)

 -- Amin Bandali <bandali@debian.org>  Fri, 15 Mar 2024 16:10:29 -0400

ulfius (2.7.15-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1063011

 -- Steve Langasek <vorlon@debian.org>  Wed, 28 Feb 2024 21:10:42 +0000

ulfius (2.7.15-2) unstable; urgency=medium

  * d/patches/test-malformed.patch: Remove test_ulfius_malformed_requests
    test when libmicrohttpd >= 1.0.0 (Closes: #1064020)
  * d/control: Use builddep pkgconf instead of pkg-config
  * d/copyright: Update copyright year to 2024

 -- Nicolas Mora <babelouest@debian.org>  Fri, 16 Feb 2024 07:28:28 -0500

ulfius (2.7.15-1) unstable; urgency=medium

  * New upstream release
  * d/symbols: update symbols
  * d/salsa-ci.yml: Add salsa CI script

 -- Nicolas Mora <babelouest@debian.org>  Mon, 13 Nov 2023 20:03:22 -0500
